unit Main;

{$mode objfpc}{$H+}

{.$DEFINE CLAUDE}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  Grids, ShellCtrls, Menus, Buttons, Spin, ActnList, ComCtrls
  , JvTabBar, JvPageList, JvTabBarXPPainter;

//,ListViewFilterEdit

type

  { TMainForm }

  TMainForm = class(TForm)
    actn_AddFormGrid: TAction;
    actn_AddFormShell: TAction;
    actn_AddFormMemo: TAction;
    actn_AddFormImage: TAction;
    actn_DockInChildPage: TAction;
    actn_ShowCaptionFromPage: TAction;
    actn_HideTab: TAction;
    actn_Exit: TAction;
    actn_DockIn: TAction;
    actn_AddParentTest: TAction;
    actn_AddMultipleTabs: TAction;
    actn_CloseSelectedTab: TAction;
    actn_AddOneTab: TAction;
    ActionList1: TActionList;
    bttnCloseTab: TButton;
    bttnAddMultipleTabs: TButton;
    bttnAddParent: TButton;
    bttnDockIn: TButton;
    bttnVisible: TButton;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    cbCloseButton: TCheckBox;
    cbAllowTabMoving: TCheckBox;
    cbFlatScrollBtns: TCheckBox;
    cbRoundedScrollBtns: TCheckBox;
    cbTabHotTracking: TCheckBox;
    cmbPainter: TComboBox;
    cmbOrientation: TComboBox;
    cmbScrollLayout: TComboBox;
    cmbTabShape: TComboBox;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    JvPageList1: TJvPageList;
    JvTabBar1: TJvTabBar;
    Label1: TLabel;
    Label2: TLabel;
    lblPainter: TLabel;
    lblOrientation: TLabel;
    lblScrollLayout: TLabel;
    lblTabShape: TLabel;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem10: TMenuItem;
    MenuItem11: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem9: TMenuItem;
    mnuTabs: TMenuItem;
    PageControl1: TPageControl;
    Separator1: TMenuItem;
    pnlBottom: TPanel;
    pnlTabsButtons: TPanel;
    SpeedButton1: TSpeedButton;
    SpinEditHeight: TSpinEdit;
    SpinFixedTabs: TSpinEdit;
    StatusBar1: TStatusBar;
    tsDesign: TTabSheet;
    tsFunction: TTabSheet;

    procedure cbFlatScrollBtnsChange(Sender: TObject);
    procedure cbRoundedScrollBtnsChange(Sender: TObject);
    procedure cmbScrollLayoutChange(Sender: TObject);
    procedure cmbTabShapeChange(Sender: TObject);
    procedure JvTabBar1TabClosed(Sender: TObject; Item: TJvTabBarItem);
    procedure JvTabBar1TabCloseQuery(Sender: TObject; Item: TJvTabBarItem;
      var CanClose: Boolean);
   // procedure JvTabBar1TabMoved(Sender: TObject; Item: TJvTabBarItem);

    procedure actn_AddMultipleTabsExecute(Sender: TObject);
    procedure actn_AddOneTabExecute(Sender: TObject);
    procedure actn_CloseSelectedTabExecute(Sender: TObject);
    procedure actn_ExitExecute(Sender: TObject);
    procedure actn_HideTabExecute(Sender: TObject);
    procedure actn_AddParentTestExecute(Sender: TObject);
    procedure actn_DockInExecute(Sender: TObject);
    procedure actn_DockInChildPageExecute(Sender: TObject);
    procedure actn_ShowCaptionFromPageExecute(Sender: TObject);
    procedure actn_AddFormGridExecute(Sender: TObject);
    procedure actn_AddFormImageExecute(Sender: TObject);
    procedure actn_AddFormMemoExecute(Sender: TObject);
    procedure actn_AddFormShellExecute(Sender: TObject);

    procedure cbCloseButtonChange(Sender: TObject);
    procedure cbAllowTabMovingChange(Sender: TObject);
    procedure cbTabHotTrackingChange(Sender: TObject);

    procedure cmbPainterChange(Sender: TObject);
    procedure cmbOrientationChange(Sender: TObject);

    procedure FormCreate(Sender: TObject);
    procedure JvTabBar1TabSelected(Sender: TObject; Item: TJvTabBarItem);

    procedure SpinEditHeightChange(Sender: TObject);
    procedure SpinFixedTabsChange(Sender: TObject);
  private
    FiFixedTabs: integer;
    FiTabMenuFixecCount:integer;
    iMeinCounter:integer;

    procedure AddOneTab;
    procedure AddFormMemo;
    procedure AddFormImage;
    procedure AddformGrid;
    procedure AddFormShell;

    procedure AddParentTest;
    procedure DockIn;
    procedure AddChildForm1;

    procedure AddMultipleTabs;
    procedure CloseSelectedTab;

    procedure RenewMenuItems(mCon:TMenuItem);
    procedure ShowCaptionFromParentPage;
  public
    property piFixedTabs:integer read FiFixedTabs write FiFixedTabs default 0;
    procedure MyMenuClick(Sender:TObject);
    // procedure CloseTabWithoutQuestion; //Tab schließen ohne Rückfrage, zb weil das Fenster ausgedockt wurde
  end;

var
  MainForm: TMainForm;

implementation

uses
  unit1 , udmJvTabBar
  ,unitMemo, unitimage,unitGrid,unitShell, uParentPage,uchildpage1;

{$R *.lfm}

{ TMainForm }




procedure TMainForm.cbTabHotTrackingChange(Sender: TObject);
begin
  JvTabBar1.HotTracking := cbTabHotTracking.Checked;
end;

procedure TMainForm.cbAllowTabMovingChange(Sender: TObject);
begin
  JvTabBar1.AllowTabMoving := cbAllowTabMoving.Checked;
end;

procedure TMainForm.cbCloseButtonChange(Sender: TObject);
begin
  JvTabBar1.CloseButton := cbCloseButton.Checked;
end;

procedure TMainForm.cmbPainterChange(Sender: TObject);
begin
  case cmbPainter.ItemIndex of
    0: JvTabBar1.Painter := dmJvTabBar.JvTabBarPainterStandard;
    1: JvTabBar1.Painter := dmJvTabBar.JvModernTabBarPainter1;
    2: JvTabBar1.Painter := dmJvTabBar.JvTabBarXPPainter1;
  end;
end;

procedure TMainForm.JvTabBar1TabCloseQuery(Sender: TObject;
  Item: TJvTabBarItem; var CanClose: Boolean);
begin
  if JvTabBar1.SelectedTab.Index <= piFixedTabs -1 then begin
     ShowMessage('Der Tab ' + Item.Caption + ' ist fixiert und kann nicht geschlossen werden!');
     CanClose:=false;
  end
  else
   CanClose := MessageDlg('Do you really want to close tab ' + Item.Caption + '?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes;
end;

procedure TMainForm.JvTabBar1TabClosed(Sender: TObject; Item: TJvTabBarItem);
begin
  RenewMenuItems(mnuTabs);
end;

procedure TMainForm.cbFlatScrollBtnsChange(Sender: TObject);
begin
  JvTabBar1.FlatScrollButtons := cbFlatScrollBtns.Checked;
end;


procedure TMainForm.cbRoundedScrollBtnsChange(Sender: TObject);
begin
  JvTabBar1.RoundedScrollButtons := cbRoundedScrollBtns.Checked;
end;

procedure TMainForm.cmbScrollLayoutChange(Sender: TObject);
begin
  JvTabBar1.ScrollButtonLayout := TJvTabBarScrollButtonLayout(cmbScrollLayout.ItemIndex);
end;

procedure TMainForm.cmbTabShapeChange(Sender: TObject);
begin
  JvTabBar1.TabShape := TJvTabShape(cmbTabShape.ItemIndex);
end;

procedure TMainForm.SpinEditHeightChange(Sender: TObject);
begin
  JvTabBar1.Height:= SpinEditHeight.Value;
  pnlTabsButtons.Height:=SpinEditHeight.Value;;
end;

procedure TMainForm.SpinFixedTabsChange(Sender: TObject);
begin
  piFixedTabs:= SpinFixedTabs.Value;
  RenewMenuItems(mnuTabs);
end;

//***** BEGIN Example 1************************************
{Zeigt wie man ein beliebiges TForm in einen neuen Tab einbettet

Shows how to embed any TForm in a new tab}

procedure TMainForm.AddOneTab;
var
  s:string;
  aForm: TForm1;
  i:integer;
  aTab:TJvTabBarItem;
begin
  s:='Ein Tab '+inttostr(iMeinCounter);

  aTab:=JvTabBar1.AddTab(s);  //offensichtlich wird auch gleichzeitig eine jvStandardpage in der Pagelist angelegt und synchronisiert.
  aTab.ImageIndex:=1;
  JvTabBar1.SelectedTab:=aTab;

  { Letztlich soll die Funktion so sein dass es eine TForm entweder gedockt/eingeklebt oder "frei fliegend" sein kann.
  }

  aForm:=TForm1.Create(self);
  aForm.Parent := JvPageList1.Pages[JvPagelist1.PageCount-1];
  //store pointer of created form for future use
  JvPageList1.Pages[JvPagelist1.PageCount-1].Tag:=PtrInt(FormMemo);
  aForm.BorderStyle:=bsNone;
  aForm.Align:=alclient;
  aForm.Label1.Caption:='Form 1 -- Number '+inttostr(iMeinCounter);
  aForm.Show;

  RenewMenuItems(mnuTabs);
  inc(iMeinCounter);
end;

procedure TMainForm.AddFormMemo;
var
  FormMemo:TFormMemo;
begin
  with jvTabBar1.AddTab('Memo_'+inttostr(iMeinCounter)) do begin
    ImageIndex:=0;
  end;
  FormMemo := TFormMemo.Create(self);
  FormMemo.Parent := JvPageList1.Pages[JvPagelist1.PageCount-1];
  //store pointer of created form for future use
  JvPageList1.Pages[JvPagelist1.PageCount-1].Tag:=PtrInt(FormMemo);
  FormMemo.BorderStyle:=bsNone;
  FormMemo.Align:=alclient;
  FormMemo.Caption:='Memo-- Number '+inttostr(iMeinCounter);
  FormMemo.Show;

  RenewMenuItems(mnuTabs);
  inc(iMeinCounter);
end;

procedure TMainForm.AddFormImage;
var
  FormImage:TFormImage;
begin
  with jvTabBar1.AddTab('Image_'+inttostr(iMeinCounter)) do begin
    ImageIndex:=1;
  end;
  FormImage:=TFormImage.Create(self);
  FormImage.Parent := TJvPageList(JvTabBar1.PageList).Pages[JvPagelist1.PageCount-1];
  //store pointer of created form for future use
  TJvPageList(JvTabBar1.PageList).Pages[JvPagelist1.PageCount-1].Tag:=PtrInt(FormImage);
  FormImage.BorderStyle:=bsNone;
  FormImage.Align:=alclient;
  FormImage.Caption:='Image-- Number '+inttostr(iMeinCounter);
  FormImage.Show;

  RenewMenuItems(mnuTabs);
  inc(iMeinCounter);
end;

//***** END Example 1************************************


//***** BEGIN Example 2************************************
{
Hier wird nur der Vorfahre aller folgenden Seiten in einen neuen Tab einbettet.
Dies erfolgt quasi von außen aus dem Mainform

Here only the ancestor of all following pages is embedded in a new tab.
This is done from the outside of the main form
}
procedure TMainForm.AddParentTest;
var
  s:string;
  aForm: TFormParentPage;
  i:integer;
  aTab:TJvTabBarItem;
begin
  s:='Ein Parent Form_'+inttostr(iMeinCounter);

  aTab:=JvTabBar1.AddTab(s);  //offensichtlich wird auch gleichzeitig eine jvStandardpage in der Pagelist angelegt und synchronisiert.
  aTab.ImageIndex:=1;
  JvTabBar1.SelectedTab:=aTab;

  { die Aufgabe ist es ein Formular in die richtige Seite der JvPagelist einzukleben.
    ob direkt mit parent oder auch über die Dockingfunktion ist erstmal egal

    Letztlich soll die Funktion so sein dass es eine TForm entweder gedockt/eingeklebt oder "frei fliegend" sein kann.
  }

  aForm:=TFormParentPage.Create(self);
  aForm.Parent := TJvPageList(JvTabBar1.PageList).Pages[JvPagelist1.PageCount-1];

  //Pointer des erzeugten Formulars in der Page der Pagelist hinterlegen
  TJvPageList(JvTabBar1.PageList).Pages[JvPagelist1.PageCount-1].Tag:=PtrInt(aForm);

  aForm.BorderStyle:=bsNone;
  aForm.Align:=alclient;
  aForm.poTabBar:=JvTabBar1;
  aForm.Label1.Caption:='ParentForm -- Number '+inttostr(iMeinCounter);
  aForm.Caption:='ParentForm -- Number '+inttostr(iMeinCounter);
  aForm.Show;

  RenewMenuItems(mnuTabs);
  inc(iMeinCounter);
end;

//***** END Example 2************************************

//***** BEGIN Example 3************************************
{
Auch hier wird TFormParentPage in einen Tab eingebettet. Allerdings ist das
schon eine Minimalversion im Mainform. TFormParentPage übernimmt alle Funktionen

TFormParentPage is also embedded in a tab here. However, this is already a
minimal version in the main form. TFormParentPage takes over all functions
}
procedure TMainForm.DockIn;
var
  s:string;
  aForm: TFormParentPage;
begin
  aForm:=TFormParentPage.Create(self);
  aForm.poTabBar:=JvTabBar1;
  //aForm.poPageList:=JvPageList1;

  s:='ParentFormParent_'+inttostr(iMeinCounter);
  aForm.psTabCaption:=s;  //Tabüberschrift setzen
  aForm.Caption:=s;    //für freifliegende Formulare

  //Debug
  s:='das sollte der Nachfahre der Form wissen -- Number '+inttostr(iMeinCounter);
  aForm.Label1.Caption:=s;

  aForm.EngageInTab;

  RenewMenuItems(mnuTabs);
  inc(iMeinCounter);
end;

//***** END Example 3************************************

//***** BEGIN Example 4************************************

{
Hier wird bereits ein Nachfahre des TFormParentPage benutzt. Mit minimalem
Aufwand im Mainform wird das einbetten und praktisch die gesamte Verwaltung
dem vorfahren überlassen

A descendant of the TFormParentPage is already used here. With minimal effort
in the main form, embedding and practically the entire administration is left
to the upstream process
}

procedure TMainForm.AddformGrid;
var
  s:string;
  aForm: TFormGrid;
begin
  aForm:=TFormGrid.Create(self);
  aForm.poTabBar:=JvTabBar1;
  //aForm.poPageList:=JvPageList1;

  s:='Grid_'+inttostr(iMeinCounter);
  aForm.psTabCaption:=s;  //Tabüberschrift setzen
  aForm.Caption:=s;    //für freifliegende Formulare

  //Debug
  s:='das sollte der Nachfahre der Form wissen -- Number '+inttostr(iMeinCounter);
  aForm.Label1.Caption:=s;

  aForm.EngageInTab;

  RenewMenuItems(mnuTabs);
  inc(iMeinCounter);
end;

procedure TMainForm.AddFormShell;
var
  s:string;
  aForm: TFormShell;
begin
  aForm:=TFormShell.Create(self);
  aForm.poTabBar:=JvTabBar1;

  s:='Shell_'+inttostr(iMeinCounter);
  aForm.psTabCaption:=s;  //Tabüberschrift setzen
  aForm.Caption:=s;    //für freifliegende Formulare

  //Debug
  s:='das sollte der Nachfahre der Form wissen -- Number '+inttostr(iMeinCounter);
  aForm.Label1.Caption:=s;

  aForm.EngageInTab;
  RenewMenuItems(mnuTabs);
  inc(iMeinCounter);
end;

procedure TMainForm.AddChildForm1;
var
  s:string;
  aForm: TChildPage1;
begin
  aForm:=TChildPage1.Create(self);
  aForm.poTabBar:=JvTabBar1;
  //aForm.poPageList:=JvPageList1;

  s:='Child Page_'+inttostr(iMeinCounter);
  aForm.psTabCaption:=s;  //Tabüberschrift setzen
  aForm.Caption:=s;    //für freifliegende Formulare

  //Debug
  s:='das sollte der Nachfahre der Form wissen -- Number '+inttostr(iMeinCounter);
  aForm.Label1.Caption:=s;

  aForm.EngageInTab;
  RenewMenuItems(mnuTabs);
  inc(iMeinCounter);
end;
//***** END Example 4************************************

procedure TMainForm.CloseSelectedTab;
begin
  JvTabBar1.CloseTab(JvTabBar1.SelectedTab);
  //RenewMenuItems(mnuTabs);    //Done in OnTabClosed
end;

procedure TMainForm.AddMultipleTabs;
begin
  AddFormMemo;
  AddFormImage;
  AddFormGrid;
  AddFormShell;

  RenewMenuItems(mnuTabs);
end;

procedure TMainForm.RenewMenuItems(mCon: TMenuItem);
var
  slSections:TStringlist;
  i:integer;
  MyItem:TMenuItem;
  sSection:string;
begin
  For i:= mCon.Count-1 downto FiTabMenuFixecCount do
  mCon.Delete(i);
  mCon.Enabled:=false;   //disable for it has no no items

  MyItem:=TMenuItem.Create(mCon);  //Trenner einfügen
  MyItem.Caption := '-';
  mCon.Add(MyItem);

  for i:=0 to jvtabbar1.Tabs.Count  -1 do
  begin
    //Besondere Behandlung eines noch existierenden Tabs im OnClosed Event
    if jvTabBar1.tabs[i] = JvTabBar1.ClosingTab then
      Continue;

    MyItem:=TMenuItem.Create(mCon);
    MyItem.Caption := jvtabbar1.Tabs[i].Caption;

    //Menüeinträge für fixed Tabs nicht klickbar machen --warum eigentlich, hinkommen sollte man in jedem Fall, schließen soll man sie nciht können
    //if i <= piFixedTabs -1 then
    //   MyItem.Enabled := false;

    //MyItem.Tag := jvtabbar1.Tabs[i].ImageIndex;
    MyItem.Tag := jvtabbar1.Tabs[i].Index;
    MyItem.ImageIndex := jvtabbar1.Tabs[i].ImageIndex;
    MyItem.OnClick:= @MyMenuClick;
    mCon.Add(MyItem);
  end;

  if mCon.Count >0 then mCon.Enabled:=true; //enable if it has Items

end;

{
}
procedure TMainForm.ShowCaptionFromParentPage;
var
  TheTag:PtrInt;
  sCaption:string;
  //iPageIndex:integer;
begin
  //iPageIndex:= TJvPageList(JvTabBar1.PageList).Pages[JvPagelist1.PageIndex]

  TheTag:= JvPageList1.ActivePage.Tag;

  //TheTag:=TJvPageList(JvTabBar1.PageList).Pages[JvPagelist1.PageIndex].Tag;
  sCaption:=TFormParentPage(Pointer(TheTag)).Caption;

  ShowMessage(sCaption);
end;

procedure TMainForm.MyMenuClick(Sender: TObject);
begin
  //showmessage('clicked : ' + TMenuItem(Sender).Caption); //just for debugging
  jvtabbar1.SelectedTab:=jvtabbar1.Tabs[TMenuItem(Sender).Tag];
end;

procedure TMainForm.cmbOrientationChange(Sender: TObject);
begin
  case cmbOrientation.ItemIndex of
    0: begin
         JvTabBar1.Orientation := toTop;
         JvTabBar1.Align := alTop;
       end;
    1: begin
         JvTabBar1.Orientation := toBottom;
         JvTabBar1.Align := alBottom;
       end;
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
//var
  //Speedbutton:TSpeedbutton;

begin
  If not assigned(dmJvTabBar) then dmJvTabBar:=TdmJvTabBar.Create(self);
  JvTabBar1.Images := dmJvTabBar.ImageList1;
  JvTabBar1.Painter := dmJvTabBar.JvTabBarPainterStandard;
  //JvTabBar1.Height:=SpinEditHeight.Value;
 SpinEditHeight.Value:=JvTabBar1.Height;

  //Speedbutton:=TSpeedbutton.Create(JvTabBar1);
  //Speedbutton.Parent:=JvTabBar1;
  //SpeedButton.Images:=dmJvTabBar.ImageList1;
  //SpeedButton.ImageIndex:=1;
  //SpeedButton.Anchors:=[akRight,akBottom];
  //Speedbutton.Show;

  //SpeedButton1.Images:=dmJvTabBar.ImageList1;
  //SpeedButton1.ImageIndex:=1;
  //

  MainMenu1.Images := dmJvTabBar.ImageList1;
  iMeinCounter:=0;

  //fixe Menüeinträge im Tabsmenü feststellen
  FiTabMenuFixecCount:=mnuTabs.Count;

  SpinFixedTabsChange(nil);
  AddMultipleTabs;

end;

procedure TMainForm.JvTabBar1TabSelected(Sender: TObject; Item: TJvTabBarItem);
begin
  StatusBar1.Panels[0].Text:=JvTabBar1.SelectedTab.Caption;
end;

//***** BEGIN Actions ************************************
{%Region 'Actions'}
procedure TMainForm.actn_ShowCaptionFromPageExecute(Sender: TObject);
begin
  ShowCaptionFromParentPage;
end;

procedure TMainForm.actn_DockInChildPageExecute(Sender: TObject);
begin
  AddChildForm1;
end;

procedure TMainForm.actn_DockInExecute(Sender: TObject);
begin
  DockIn;
end;

procedure TMainForm.actn_AddParentTestExecute(Sender: TObject);
begin
  AddParentTest;
end;

procedure TMainForm.actn_HideTabExecute(Sender: TObject);
begin
  JvTabBar1.SelectedTab.Visible:=false;
end;

procedure TMainForm.actn_AddOneTabExecute(Sender: TObject);
begin
  AddOneTab;
end;

procedure TMainForm.actn_CloseSelectedTabExecute(Sender: TObject);
begin
  CloseSelectedTab;
end;

procedure TMainForm.actn_AddMultipleTabsExecute(Sender: TObject);
begin
  AddMultipleTabs;
end;

procedure TMainForm.actn_ExitExecute(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TMainForm.actn_AddFormGridExecute(Sender: TObject);
begin
  AddFormGrid;
end;

procedure TMainForm.actn_AddFormImageExecute(Sender: TObject);
begin
  AddFormImage;
end;

procedure TMainForm.actn_AddFormMemoExecute(Sender: TObject);
begin
  AddFormMemo;
end;

procedure TMainForm.actn_AddFormShellExecute(Sender: TObject);
begin
  AddFormShell;
end;
{%Endregion}
//***** END Actions ************************************

end.

